import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
public class Figure  extends Mover
{
    private int speed=10;
    private int vSpeed=0;
    private int acceleration=2;
    private int jumpStrength=-15;
    int counterright = 0;
    int counterleft = 0;
    public Figure()
    {
    }
 
    public void act(){
        checkKeys();
        checkFall();
        checkCeiling();
        onLiftMoveRight();
        onLiftMoveLeft();
        onLift2MoveUp();
        onLift2MoveDown();
        onLift2upsidedownMoveUp();
        onLift2upsidedownMoveDown();
        moveBlockLeft();
        moveBlockRight();
        checkBounce();
        checkDeath();
        checkSpikes();
        checkGate1();
        checkGate2();
        checkGate3();
        removeGate1();
        removeGate2();
        removeGate3();
        checkSpikesLeftMove();
        checkFireball();
        checkMonster1();
        checkMonster1left();
        checkMonster1right();
        checkMonster2upper();
        checkMonster2lower();
        win();
    }
    private void checkKeys(){
        if(Greenfoot.isKeyDown("left")){
            moveLeft();
            counterleft++;
            if(counterleft==0){
                setImage("Figureleft1.png");
            }
            if(counterleft==2){
                setImage("Figureleft2.png");
            }
            if(counterleft==3){
                setImage("Figureleft3.png");
            }
            if(counterleft==5){
                setImage("Figureleft4.png");
            }
            if(counterleft==6){
                counterleft=0;
            }
        }
        if(Greenfoot.isKeyDown("right")){
            moveRight();
            counterright++;
            if(counterright==0){
                setImage("Figureright1.png");
            }
            if(counterright==2){
                setImage("Figureright2.png");
            }
            if(counterright==3){
                setImage("Figureright3.png");
            }
            if(counterright==5){
                setImage("Figureright4.png");
            }
            if(counterright==6){
                counterright=0;
            }
        }
        if(Greenfoot.isKeyDown("space")){       
            jump();
        }
    }
    public void jump(){
        if(onGround()||onGround2()||onLift()||onLift2()||onLift2upsidedown()||onGround3()||inBlock3()||inBlock31()||inBlock32()||inBlock33()||inBlock34()||onBlockLeft()||onBlockRight()){
        vSpeed=jumpStrength;
        fall();
        }
    }
    public void checkFall(){
        if(onGround()||onGround2()||onLift()||onLift2()||onLift2upsidedown()||onGround3()||inBlock3()||inBlock31()||inBlock32()||inBlock33()||inBlock34()||onBlockLeft()||onBlockRight()){
            vSpeed=0;
        }else{
            fall();
        }
    }
    public boolean canSee(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;     
    }
    public boolean canSeeSpikes(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 20, clss);
        return actor != null;     
    }
    public boolean canSeeButton(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 30, clss);
        return actor != null;     
    }
    public void removeGate1()
    {
        Actor Button1 = getOneIntersectingObject(Button1.class);
            if(canSeeButton(Button1.class)){
            ((Levels)getWorld()).removeGate1();
        }
    }
    public void removeGate2()
    {
        Actor Button2 = getOneIntersectingObject(Button2.class);
            if(canSeeButton(Button2.class)){
            ((Levels)getWorld()).removeGate2();
        }
    }
    public void removeGate3()
    {
        Actor Button3 = getOneIntersectingObject(Button3.class);
            if(canSeeButton(Button3.class)){
            ((Levels)getWorld()).removeGate3();
        }
    }
    public void win()
    {
        Actor flag = getOneIntersectingObject(Finish.class);
            if(canSee(Finish.class)){
            ((Levels)getWorld()).addLevel();
        }
    }
 
    public void checkDeath(){
        if(getY()==499){
            die();
        }
    }
    public void die(){
        setLocation(100,420);
        vSpeed=0;
    }
    public void dieGates(){
        ((Levels)getWorld()).resetLevel();
    }
    public void checkSpikes(){
        if(canSeeSpikes(Spikes.class)){
            die();
        }
    }
    public void checkSpikesLeftMove(){
        if(canSeeSpikes(SpikesLeftMove.class)){
            die();
        }
    }
    public void checkGate1(){
        Gate1 a = (Gate1) getOneIntersectingObject(Gate1.class);
        if(canSee(Gate1.class)||canSeeSpikes(Gate1.class)){
            die();
        }
    }
    public void checkGate2(){
        Gate2 a = (Gate2) getOneIntersectingObject(Gate2.class);
        if(canSee(Gate2.class)){
            die();
        }
    }
    public void checkGate3(){
        Gate3 a = (Gate3) getOneIntersectingObject(Gate3.class);
        if(canSee(Gate3.class)){
            die();
        }
    }
    public void checkFireball(){
        if(canSeeSpikes(Fireball.class)){
            die();
        }
    }
    public void checkMonster1(){
        if(canSee(Monster1.class)){
            die();
        }
    }
    public void checkMonster1left(){
        if(canSee(Monster1left.class)){
            die();
        }
    }
    public void checkMonster1right(){
        if(canSee(Monster1right.class)){
            die();
        }
    }
    public void checkMonster2upper(){
        if(canSee(Monster2upper.class)){
            die();
        }
    }
    public void checkMonster2lower(){
        if(canSee(Monster2lower.class)){
            die();
        }
    }
    public boolean onGround(){
        Block a = (Block) getOneObjectAtOffset(0,23,Block.class);
        return a !=null;
    }
    public boolean onBlockLeft(){
        BlockLeft a = (BlockLeft) getOneObjectAtOffset(0,34,BlockLeft.class);
        return a !=null;
    }
    public boolean onBlockRight(){
        BlockRight a = (BlockRight) getOneObjectAtOffset(0,36,BlockRight.class);
        return a !=null;
    }
    public void moveBlockLeft(){
        if(onBlockLeft()){
            setLocation(getX()-11,getY());
        }
    }
    public void moveBlockRight(){
        if(onBlockRight()){
            setLocation(getX()+11,getY());
        }
    }
    //CEILING CODES NEXT FEW
    public boolean onCeiling(){
        Block a = (Block) getOneObjectAtOffset(0,-28,Block.class);
        return a !=null;
    }
    public boolean onCeiling2(){
        Block2 a = (Block2) getOneObjectAtOffset(0,-33,Block2.class);
        return a !=null;
    }
    public boolean inGround1(){
        Block a = (Block) getOneObjectAtOffset(0,-23,Block.class);
        return a !=null;
    }
    public boolean inGround2(){
        Block a = (Block) getOneObjectAtOffset(0,-18,Block.class);
        return a !=null;
    }
    public boolean inGround3(){
        Block a = (Block) getOneObjectAtOffset(0,-13,Block.class);
        return a !=null;
    }
    public boolean inGround4(){
        Block a = (Block) getOneObjectAtOffset(0,-8,Block.class);
        return a !=null;
    }
    public void checkCeiling(){
        if(onCeiling()||inGround1()||inGround2()||inGround3()||inGround4()){
            setLocation(getX(),getY()+5);
        }
    }
    public boolean onLift(){
        Lift a = (Lift) getOneObjectAtOffset(0,34,Lift.class);
        return a !=null;
    }
    public boolean onLift2(){
        Lift2 a = (Lift2) getOneObjectAtOffset(0,34,Lift2.class);
        return a !=null;
    }
    public boolean onLift2upsidedown(){
        Lift2upsidedown a = (Lift2upsidedown) getOneObjectAtOffset(0,34,Lift2upsidedown.class);
        return a !=null;
    }
    public void onLiftMoveRight(){
        if(onLift()){
            Lift a = (Lift) getOneObjectAtOffset(0,34,Lift.class);
            if (a.getRotation()==0){
            move(8);
            }
        }
    }
    public void onLiftMoveLeft(){
        if(onLift()){
            Lift a = (Lift) getOneObjectAtOffset(0,34,Lift.class);
            if (a.getRotation()==180){
            move(-8);
            }
        }
    }
    public void onLift2MoveUp(){
        if(onLift2()){
            Lift2 a = (Lift2) getOneObjectAtOffset(0,34,Lift2.class);
            if (a.getRotation()==270){
            setLocation(getX(),getY()-6);
            }
        }
    }
    public void onLift2MoveDown(){
        if(onLift2()){
            Lift2 a = (Lift2) getOneObjectAtOffset(0,34,Lift2.class);
            if (a.getRotation()==90){
            setLocation(getX(),getY()+6);
            }
        }
    }
    public void onLift2upsidedownMoveUp(){
        if(onLift2upsidedown()){
            Lift2upsidedown a = (Lift2upsidedown) getOneObjectAtOffset(0,34,Lift2upsidedown.class);
            if (a.getRotation()==270){
            setLocation(getX(),getY()-6);
            }
        }
    }
    public void onLift2upsidedownMoveDown(){
        if(onLift2upsidedown()){
            Lift2upsidedown a = (Lift2upsidedown) getOneObjectAtOffset(0,34,Lift2upsidedown.class);
            if (a.getRotation()==90){
            setLocation(getX(),getY()+6);
            }
        }
    }
    public boolean onGround2(){
        Block2 a = (Block2) getOneObjectAtOffset(0,33,Block2.class);
        return a !=null;
    }
    public boolean onGround3(){
        Block3 a = (Block3) getOneObjectAtOffset(0,33,Block3.class);
        return a !=null;
    }
    public boolean inBlock3(){
        Block3 a = (Block3) getOneObjectAtOffset(0,30,Block3.class);
        return a !=null;
    }
    public boolean inBlock31(){
        Block3 a = (Block3) getOneObjectAtOffset(0,31,Block3.class);
        return a !=null;
    }
    public boolean inBlock32(){
        Block3 a = (Block3) getOneObjectAtOffset(0,32,Block3.class);
        return a !=null;
    }
    public boolean inBlock33(){
        Block3 a = (Block3) getOneObjectAtOffset(0,29,Block3.class);
        return a !=null;
    }
    public boolean inBlock34(){
        Block3 a = (Block3) getOneObjectAtOffset(0,28,Block3.class);
        return a !=null;
    }
    public void checkBounce(){
        if(onSpring()){
            vSpeed=-28;
            fall();
        }
        if(onSpring1()){
            vSpeed=-28;
            fall();
        }
    }
    public boolean onSpring(){
         Actor spring = getOneObjectAtOffset(0,28,Spring.class);
         return spring !=null;
    }
    public boolean onSpring1(){
         Actor spring1 = getOneObjectAtOffset(0,28,Spring1.class);
         return spring1 !=null;
    }
    public void fall(){
        setLocation(getX(),getY()+vSpeed);
        vSpeed=vSpeed+acceleration;
    }
    public void moveRight(){
        setLocation(getX()+speed,getY());
    }
    public void moveLeft(){
        setLocation(getX()-speed,getY());
    }
}